setup-apkcache.in 2.97 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24
#!/bin/sh

PREFIX=

. "$PREFIX/lib/libalpine.sh"

usage() {
        cat <<__EOF__
usage: setup-apkcache [-h] [DIR]

Setup apk caching.

If DIR is not specified user will be asked for location.

options:
 -h  Show this help 
__EOF__
        exit 1
}

is_mounted() {
	awk '{print $2}' /proc/mounts | grep -q "^$1$"
}

25 26 27 28 29 30 31 32 33 34 35 36 37
find_fstab_mount_point() {
	local dir="$1"
	local res=
	while [ -n "$dir" ]; do
		res=$(awk "\$2 == \"$dir\" {print \$2}" /etc/fstab)
		if [ -n "$res" ]; then
			echo $res
			return
		fi
		dir=${dir%/*}
	done
}

Natanael Copa's avatar
Natanael Copa committed
38 39
# figure out mount point
find_mount_point() {
40 41 42 43 44 45
	local dir=$(find_fstab_mount_point $1)
	if [ -d "$dir" ] && [ "$dir" != "/" ]; then
		echo $dir
		return
	fi

Natanael Copa's avatar
Natanael Copa committed
46 47 48 49 50 51
	local dir="$1"
	while ! [ -d "$dir" ]; do
		dir=${dir%/*}
	done
	local fs_id=$(stat -f -c %i "$dir")
	local parent="${dir%/*}"
52
	while [ -n "$dir" ] && [ "$(stat -f -c %i $parent/)" = "$fs_id" ]; do
Natanael Copa's avatar
Natanael Copa committed
53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76
		dir=$parent
		parent=${parent%/*}
	done
	[ -z "$dir" ] && dir=/
	echo $dir
}

get_mount_opts() {
	local mnt="$1"
	awk "\$2 == \"$mnt\" {gsub(/,/, \" \", \$4); print \$4}" /proc/mounts
}

is_mounted_ro() {
	local mnt="$1"
	local opts=$(get_mount_opts $mnt)
	local opt=
	for opt in $opts; do
		if [ "$opt" = "ro" ]; then
			return 0
		fi
	done
	return 1
}

77 78 79 80 81 82 83
# get the fstype of the given mount point
mount_fstype() {
	# we only want the last mount in case there are several
	awk -v mnt="$1" '$2 == "/" {fstype = mnt} END {print fstype}' \
		/proc/mounts
}

Natanael Copa's avatar
Natanael Copa committed
84 85 86 87 88 89 90 91 92 93 94 95
apk_cache_help() {
	cat <<__EOF__

Packages installed from network can be cached locally to be available during
boot, before the network is started. Specifying a directory here will make apk
cache the packages locally in this directory.

Enter 'none' if you do not want to cache packages from network.

__EOF__
}

Natanael Copa's avatar
Natanael Copa committed
96 97 98 99 100 101 102 103 104 105
while getopts "h" opt; do
        case $opt in
		h) usage;;
        esac
done
shift $(( $OPTIND - 1 ))

# try auto detetect what we suggest
suggestion=
if [ -L /etc/apk/cache ]; then
Natanael Copa's avatar
Natanael Copa committed
106 107
	suggestion=$(readlink /etc/apk/cache)
fi
Natanael Copa's avatar
Natanael Copa committed
108 109 110 111 112 113 114 115 116 117 118 119

if [ -z "$suggestion" ] && [ -f /etc/lbu/lbu.conf ]; then
	. /etc/lbu/lbu.conf
	if [ -n "$LBU_MEDIA" ]; then
		suggestion=/media/$LBU_MEDIA/cache
	fi
fi

if [ -z "$suggestion" ] && [ -L /dev/usbdisk ]; then
	suggestion=/media/usb/cache
fi

120 121 122 123
if [ -z "$suggestion" ] && [ "$(mount_fstype /)" != "tmpfs" ]; then
	suggestion=/var/cache/apk
fi

Natanael Copa's avatar
Natanael Copa committed
124 125 126 127 128 129
if [ -z "$suggestion" ]; then
	suggestion=none
fi
cachedir=$1

while [ -z "$cachedir" ]; do
Natanael Copa's avatar
Natanael Copa committed
130
	echo -n "Enter apk cache directory (or '?' or 'none') [$suggestion]: "
Natanael Copa's avatar
Natanael Copa committed
131
	default_read cachedir $suggestion
Natanael Copa's avatar
Natanael Copa committed
132 133 134 135
	if [ "$cachedir" = "?" ]; then
		apk_cache_help
		cachedir=
	fi
Natanael Copa's avatar
Natanael Copa committed
136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164
done

if [ "$cachedir" = "none" ]; then
	exit 0
fi

mount=$(find_mount_point $cachedir)

cleanup=

if ! is_mounted $mount; then
	mount $mount || exit 1
	cleanup="umount"
elif is_mounted_ro $mount; then
	mount -o remount,rw $mount || exit 1
	cleanup="remount"
fi

mkdir -p $cachedir
if [ -L /etc/apk/cache ]; then
	rm -f /etc/apk/cache
fi
ln -s $cachedir /etc/apk/cache

case "$cleanup" in
	umount) umount $mount;;
	remount) mount -o remount,ro $mount;;
esac